Items in saved pages missing thumbnail when saved from outside the article view.
Closed, ResolvedPublic

Description

Repro steps

  1. Tap on save on any cell w/ a save button (currently only in the "more like" lists and non-nearby feed items)
  2. Go to saved pages

Expected results

The thumbnail I see in the feed is also present on saved pages

Actual results

The saved page cell has no thumbnail.

From Home:

In Saved:


Dev Notes

This is because there's no MWKArticle w/ a thumbnail/lead image to use for the saved page's thumbnail. Previously the only way to save a page was by visiting it, but this is no longer the case.

Proposed solution

Observe article download notifications, and reload any visible cells related to the title which was saved. See WMFArticleContainerViewController for observation code, and modifying WMFArticleListCollectionViewControllerto make the same observations and update its cells. This supersedes the denormalization approach due to simplicity & comprehensiveness (also includes extracts & entity descriptions).

Denormalization approach (deprecated)

Add a thumbnailURL property to saved page entries, and add it as a required property when saving a page. IOW, you can only add a saved page entry if you have both a MWKTitle and a thumbnail URL. We can lazily migrate existing saved page data by copying existing article thumbnails when the saved page list is created (i.e. no need to do a startup-blocking migration).

BGerstle-WMF updated the task description. (Show Details)
BGerstle-WMF raised the priority of this task from to Needs Triage.
BGerstle-WMF moved this task to Needs Triage on the Wikipedia-iOS-App-Backlog board.
BGerstle-WMF added a subscriber: BGerstle-WMF.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 25 2015, 2:45 PM
BGerstle-WMF updated the task description. (Show Details)Sep 25 2015, 2:50 PM
BGerstle-WMF set Security to None.

This also happens on the history tab if you:

  1. Go to view an article
  2. Quickly, before the full mobileview response comes back, go to History

Expected result

History entry has correct title, description/snippet?, & thumbnail.

Actual result

Title-only History entry w/ placeholder graphic:

JMinor triaged this task as Normal priority.Sep 28 2015, 9:12 PM
JMinor added a project: iOS-app-v5-beta.

Simple solution discussed with @Mhurd & @Fjalapeno:

  • request larger images for "regular" search results (matching related thumbnail size, to fit in thumbnail)
  • store the URL as a property on MWKHistoryEntry and MWKSavedPageEntry

Other options we discussed:

  • Change cell appearance while article/image is downloading or if there isn't an image
  • Download necessary data if not provided at entry creation time
BGerstle-WMF updated the task description. (Show Details)Oct 15 2015, 9:42 PM

Checked Saved and History for correct display of thumnail imgs (with 5.0.0 (408) on iPad iOS 9.0.2)

JMinor closed this task as Resolved.Nov 18 2015, 9:10 PM
JMinor added a subscriber: JMinor.